package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.TSSDPolicyOwner;
import com.sa.ibiz.demo.demo.service.TSSDPolicyOwnerService;
import com.sa.ibiz.demo.demo.service.dto.TSSDPolicyOwnerSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/tssdpolicyowner")
public class TSSDPolicyOwnerResource
{
	@Autowired
	private TSSDPolicyOwnerService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<TSSDPolicyOwner> checkKey(@Validated @RequestBody TSSDPolicyOwner data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略所有者[checkKey]操作发生错误","TSSDPolicyOwner",data.getTssdpolicyownerid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<TSSDPolicyOwner> create(@Validated @RequestBody TSSDPolicyOwner data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略所有者[create]操作发生错误","TSSDPolicyOwner",data.getTssdpolicyownerid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<TSSDPolicyOwner> get(@Validated @PathVariable String id){
		TSSDPolicyOwner data=new TSSDPolicyOwner();
		data.setTssdpolicyownerid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("任务时刻策略所有者[get]操作发生错误","TSSDPolicyOwner",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<TSSDPolicyOwner> getDraft(@Validated @RequestBody TSSDPolicyOwner data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略所有者[getDraft]操作发生错误","TSSDPolicyOwner","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<TSSDPolicyOwner> update(@Validated @RequestBody TSSDPolicyOwner data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略所有者[update]操作发生错误","TSSDPolicyOwner",data.getTssdpolicyownerid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<TSSDPolicyOwner> remove(@Validated @RequestBody TSSDPolicyOwner data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略所有者[remove]操作发生错误","TSSDPolicyOwner",data.getTssdpolicyownerid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<TSSDPolicyOwner>> searchDefaultPage(@Validated @RequestBody TSSDPolicyOwnerSearchFilter filter){
		Page<TSSDPolicyOwner> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<TSSDPolicyOwner>> listDefault(@Validated @RequestBody TSSDPolicyOwnerSearchFilter filter){
		List<TSSDPolicyOwner> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
